import java.util.ArrayList;

public class Krug implements Cloneable{
  protected double volumen;
  protected double fllung;

  public Krug(double v, double f){
    volumen=v;
    setFllung(f);
  }

  public double getVolumen(){return volumen;}

  public double getFllung(){return fllung;}

  public double nimm(double angebot){
    double menge=getVolumen()-getFllung();
    if(angebot<menge) menge=angebot;
    fllung+=menge;
    return menge;
  }

///fire
  public void schtteIn(Krug krug){
    double menge=krug.nimm(getFllung());
    fllung-=menge;
    this.fireTransferEvent(krug, -menge);
    krug.fireTransferEvent(this, menge);
  }

  void setFllung(double neu){
    if(neu<0) neu=0;
    else if(neu>volumen) neu=volumen;
    fllung=neu;
    neu=neu-fllung;
    this.fireTransferEvent(this, neu);
  }///fire

  public String toString(){
    return getFllung()+".."+getVolumen();
  }

  public Object clone(){
    Object ret;
    try{ret=super.clone();}
    catch(CloneNotSupportedException ex){ret=null;}
    listeners=(ArrayList)listeners.clone();
    return ret;
  }

  public boolean equals(Object obj){
    if(!(obj instanceof Krug)) return false;
    return ((Krug)obj).getVolumen()==getVolumen();
  }

  public int hashCode(){return (int)getVolumen();}
  ///listen
  private ArrayList listeners=new ArrayList();

  public void addTransferListener(TransferListener g){
    listeners.add(g);
  }
  public void removeTransferListener(TransferListener g){
    listeners.remove(g);
  }

  protected void fireTransferEvent(Krug partner, double delta){
    TransferEvent te=new TransferEvent(this, partner, delta);
    for(int i=0, n=listeners.size(); i<n; i++)
      ((TransferListener)listeners.get(i)).transferHappened(te);
  }///listen
}
