public class Damen{
  //Dieses Programm ist absolut nicht objektorientiert ausgerichtet
  //Spaltennr  0123456
  //
  //zeile0    D******    Die aktuelle Spalte ist immer frei,
  //zeile1    \*D***/    weil spaltenweise vorgegangen wird.
  //zeile2    *D***/*
  //zeile3    **\*/**
  //zeile4    ---X---
  //zeile5    **/*\**
  //zeile6    */***\*

  //globale Variablen
  static int anzahl=8;      //Standard-Anzahl der Damen
  static int[] spalte;      //ZEILENnummern der Damen
  static boolean[] zeile;    //true = Zeile noch unbedroht
  static boolean[] steigend;//true = steigende Diagonale noch unbedroht
  static boolean[] fallend; //true = fallende Diagonale noch unbedroht
  static int gefundene=0;

  public static void ausgabe(){
    for(int i=0; i<anzahl; i++) System.out.print((spalte[i]+1)+" ");
    System.out.println();
    gefundene++;
  }

  public static void findeAlleInSpalte(int sp){
    for(int z=0; z<anzahl; z++){//probiere alle Zeilen
      if(zeile[z] && steigend[sp+z] && fallend[sp+anzahl-1-z]){//noch frei?
        spalte[sp]=z;//Dame hinsetzen
        zeile[z]=false; steigend[sp+z]=false; fallend[sp+anzahl-1-z]=false;//Schusslinien blockieren
        if(sp==anzahl-1) ausgabe(); else findeAlleInSpalte(sp+1);
        zeile[z]=true;  steigend[sp+z]=true;  fallend[sp+anzahl-1-z]=true; //Schusslinien freimachen
      }
    }
  }

  public static void main(String[] args){
    if(args.length>0) anzahl=Integer.parseInt(args[0]);
    System.out.println("Alle Lsungen des "+anzahl+"-Damen Problems:");
    spalte=new int[anzahl];
    zeile=new boolean[anzahl];
    steigend=new boolean[2*anzahl-1];
    fallend=new boolean[2*anzahl-1];
    for(int i=anzahl-1; i>=0; i--) zeile[i]=true;
    for(int i=2*anzahl-2; i>=0; i--){steigend[i]=true; fallend[i]=true;}
    findeAlleInSpalte(0);
    System.out.println("Das waren "+gefundene+" Lsungen.");
  }
}
