/* Der Rechner denkt sich vier Ziffern. Der Mensch muss diese
   in der richtigen Reihenfolge erraten. Dazu bekommt er nach jedem
   Rateschritt vom Rechner Hinweise. Ein Minus bedeutet, dass eine Ziffer
   richtig erraten wurde, ein Plus auch, jedoch ist sie sogar an der
   richtigen Stelle. Man wei jedoch niemals, welches Zeichen welcher
   geratenen Ziffer entspricht.
   Wird das Programm mit der Option test gestartet, so gibt es die
   zu ratenden Ziffern gleich am Anfang aus.
 
   Im Schwester-Verzeichnis obj befindet sich die umgekehrte Form des
   Programms, bei dem der Rechner die Zahlen rt.
*/
public class Mastermind{
  static int steine=4;

  public static void main(String[] args){
    int[] zahlen=new int[steine];
    boolean test=(args!=null && args.length>0 && args[0].equals("test"));
    for(int i=0; i<steine; i++){
      boolean doppel;
      do{
        doppel=false;
        zahlen[i]=(int)Math.floor(10*Math.random());
        for(int j=0; j<i; j++) if(zahlen[i]==zahlen[j]) doppel=true;
      }while(doppel);
      if(test) System.out.print(zahlen[i]);
    }
    System.out.println("\nGib eine Zahl aus "+steine+" Ziffern ein:");
    int zr, pr, durchgang=0;
    do{
      int eingabe=LineInput.readInt();
      int[] tips=new int[steine];
      int[] nums=(int[])zahlen.clone();//Kopie der zu erratenden Zahlen
      zr=pr=0;
      for(int i=steine-1; i>=0; i--){
        tips[i]=eingabe%10;
        if(tips[i]==nums[i]){//Test auf richtige Ziffer an richtiger Stelle
          pr++;
          tips[i]=-1;  nums[i]=-2;
        }
        eingabe/=10;
      }
      for(int i=0; i<steine; i++)
        for(int j=0; j<steine; j++)
          if(tips[j]==nums[i]){//Test auf richtige Ziffer irgendwo
            zr++;
            tips[j]=-1;  nums[i]=-2;
          }
      for(int i=0; i<pr; i++) System.out.print("+");
      for(int i=0; i<zr; i++) System.out.print("-");
      System.out.println();
      durchgang++;
    }while(pr<steine && durchgang<12);
    System.out.print("Die zu findende Zahl lautete ");
    for(int i=0; i<steine; i++) System.out.print(zahlen[i]);
		System.out.println("\n");
  }
}
