public class Merge{
  public static int[] zahlen1={2, 5, 5, 12, 13, 19, 22, 22, 50, 50, 50};
  public static int[] zahlen2={0, 2, 12, 12, 20, 30, 50, 100};

/*  Die folgende Methode nimmt zwei int-Arrays entgegen, die, jedes fr sich, schon
  in aufsteigender Reihenfolge sortiert sind. (Oben stehen schon zwei solche.)
  Die beiden Arrays werden nun so in ein weiteres groes int-Array abgelegt, dass
  dieses auch sortiert ist. Dieses groe int-Array wird von merge zurckgeliefert.
  (Auf die Krze der Schleife bin ich sehr stolz.)
*/
  public static int[] merge(int[] z1, int[] z2){
    int le1=z1.length; int le2=z2.length; int leg=le1+le2;
    int[] zg=new int[leg];
    int n1=0, n2=0;
    boolean eins;

    for(int ng=0; ng<leg; ng++){
      eins=n2>=le2;
      if(!eins && n1<le1) eins=z1[n1]<z2[n2];
      zg[ng]=eins?z1[n1++]:z2[n2++];
    }
    return zg;
  }

/*  Wie oben aber mit GOTO-Nachbildung durch Labels.
    Die Methode ist sehr undurchsichtig.
*/
  public static int[] merge2(int[] z1, int[] z2){
    int le1=z1.length, le2=z2.length, leg=le1+le2;
    int[] zg=new int[leg];
    int n1=0, n2=0;

    for(int ng=0; ng<leg; ng++){        lab0:{lab1:{lab2:{
      if(n1>=le1) break lab2;
      if(n2>=le2) break lab1;
      if(z2[n2]>z1[n1]) break lab1;     }//Ende lab2
      zg[ng]=z2[n2++];
      break lab0;                       }//Ende lab1
      zg[ng]=z1[n1++];                  }//Ende lab0
    }
    return zg;
  }

/*  Die folgende Methode dreht die Reihenfolge in einem int-Array um. So ist ein
  vorher aufsteigend sortiertes Array nachher absteigend sortiert.
*/
  public static void drehUm(int[] zahlen){
    int hilf, vorne=-1, hinten=zahlen.length;
    while(++vorne<--hinten){
      hilf=zahlen[vorne];
      zahlen[vorne]=zahlen[hinten];
      zahlen[hinten]=hilf;
    }
  }

  public static void main(String[] args){
    int[] ergebnis=merge(zahlen1, zahlen2);
    for(int i=0; i<ergebnis.length; i++) System.out.print(ergebnis[i]+" ");
    System.out.println();
    drehUm(ergebnis);
    for(int i=0; i<ergebnis.length; i++) System.out.print(ergebnis[i]+" ");
    System.out.println();
  }
}
