import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.awt.GridLayout;

public class BruchRechner extends JPanel implements ActionListener{
  private JTextField eingabe;
  private JLabel oben, unten, vorzeichen, bruchstrich;
  private Bruch ergebnis=new Bruch();
  
  public BruchRechner(){//im Konstruktor wird das Aussehen festgelegt
    //es folgen die Bestandteile des sichtbaren Bruches
    bruchstrich=new JLabel("--------------------------------");
    oben=new JLabel("0",SwingConstants.CENTER);
    unten=new JLabel("1",SwingConstants.CENTER);
    JPanel p=new JPanel(new GridLayout(3,1));
    p.add(oben); p.add(bruchstrich); p.add(unten);
    add(p);
    //hier noch das Eingabefeld
    eingabe=new JTextField("0",20);
    add(eingabe);
    eingabe.addActionListener(this);
  }
  
  public void actionPerformed(ActionEvent ev){//hier wird auf Enter reagiert, dh. gerechnet
    long z,n; Long c;
    String op="+*-/";
    int opnum;
    String ss=eingabe.getText();
    char e=ss.charAt(ss.length()-1);
    for (opnum=op.length(); --opnum>=0;){
      if (e==op.charAt(opnum)) {ss=ss.substring(0,ss.length()-1); break;}
    }
    int trenn=ss.indexOf("/");
    if (trenn==-1){
      n=1;
      trenn=ss.length();
    }else{
      c=Long.valueOf(ss.substring(trenn+1));
      n=c.longValue();
    }
    c=Long.valueOf(ss.substring(0,trenn));
    z=c.longValue();
    Bruch b=new Bruch(z,n);
    switch(opnum){
      case 0: ergebnis.add(b);  break;
      case 1: ergebnis.mult(b); break;
      case 2: ergebnis.subt(b); break;
      case 3: ergebnis.div(b);  break;
      default: ergebnis=b;
    }
    oben.setText(ergebnis.toString(Bruch.OBEN));
    unten.setText(ergebnis.toString(Bruch.UNTEN));
    eingabe.selectAll();
    eingabe.requestFocus();
  }
  
  public static void main(String[] args){
    JFrame frame=new JFrame("Bruchrechner");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.getContentPane().add("Center", new BruchRechner());
    frame.pack();
    frame.show();
  }
}
