import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;

/* Dieses Programm verwendet Moiree2.java, und spielt ein wenig mit Farbe.
 */
public class Moiree2Frame extends JFrame implements ActionListener{
  Moiree2 moi;
  Random zufall;

  public Moiree2Frame(){
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    Container c=getContentPane();
    Moiree2 m=new Moiree2(Color.blue);
    c.add(m,BorderLayout.CENTER);
    moi=m;
    JButton b=new JButton("Farbe");
    c.add(b, BorderLayout.SOUTH);
    b.addActionListener(this);
    zufall=new Random();
  }

  public Moiree2Frame(String berschrift){
    this();//macht dasselbe wie Konstruktor mit ()
    setTitle(berschrift);
  }
  
  public void actionPerformed(ActionEvent e){
    moi.setFarbe(new Color(zufall.nextInt()));
    repaint();
  }

  public static void main(String[] args){
    Moiree2Frame f=new Moiree2Frame("main von Moiree2Frame.java");
    f.pack();
    f.show();
  }
}
