import javax.swing.*;
import java.awt.BorderLayout;
import java.awt.event.*;

/* Ein kleines Programm, das genau das tut, was der Name sagt.
 */
public class Primtester extends JComponent implements ActionListener{
  JTextField eingabe;
  JButton test;
  JLabel ausgabe;

  public Primtester(){
    eingabe=new JTextField();
    test=new JButton("Test");
    ausgabe=new JLabel(" ");
    this.setLayout(new BorderLayout()); //this knnte man auch weglassen!
    this.add(eingabe,BorderLayout.CENTER);
    this.add(test,BorderLayout.EAST);
    this.add(ausgabe,BorderLayout.SOUTH);
    test.addActionListener(this);
    eingabe.addActionListener(this);
  }

  public void actionPerformed(ActionEvent e){
    String t=eingabe.getText();
    int z,i;
    try{
      z=Integer.parseInt(t);
      t="Primzahl";
      ausgabe.setText(t);
      for(i=2; i<z/2; i++)
        if(z%i==0) t="keine Primzahl";
      ausgabe.setText(t);
      eingabe.selectAll();
      eingabe.requestFocus();
    } catch (NumberFormatException ex){
        ausgabe.setText("Das ist keine ganze Zahl.");
      }
  }

  public static void main(String[] args){
    JFrame f=new JFrame("Primtester");
    f.setDefaultCloseOperation(f.EXIT_ON_CLOSE);
    f.getContentPane().add(new Primtester());
    f.pack();
    f.show();
  }
}
