unit Kollektion;

interface
  function  istLeer:boolean;
  procedure einfuegen(zahl:integer);
  procedure entfernen(zahl:integer);
  function  wieOftDrin(zahl:integer):integer;

implementation
  type
    PKnoten=^TKnoten;
    TKnoten=record
      info:integer;
      next:PKnoten
    end;

  var start:PKnoten;

  procedure init;
  begin
    start:=nil
  end;

  function istLeer:boolean;
  begin
    istLeer:=(start=nil)
  end;

  procedure einfuegen(zahl:integer);
  var element:PKnoten;
  begin
    new(element);
    element^.next:=start;
    element^.info:=zahl;
    start:=element;
  end;

  function wieOftDrin(zahl:integer):integer;
  var p:PKnoten;
      n:integer;
  begin
    n:=0;
    p:=start;
    while p<>nil do begin
      if p^.info=zahl then n:=n+1;
      p:=p^.next;
    end;
    wieOftDrin:=n;
  end;

  procedure entfernen(zahl:integer);
  var zero:TKnoten;
      vor,lauf:PKnoten;
  begin
    zero.next:=start;
    vor :=@zero;
    lauf:=start;
    while lauf<>nil do begin
      if lauf^.info=zahl then begin
        vor^.next:=lauf^.next;
        dispose(lauf);
        lauf:=nil;
        start:=zero.next;
      end
      else begin
        vor :=lauf;
        lauf:=lauf^.next;
      end;
    end;
  end;

{Die Kollektion muss vor dem Gebrauch initialisiert werden.}
begin
  init;
end.
