/* Dieser Job ermittelt alle Primzahlzwillinge in einem bestimmten
   Bereich. Die Implementation ist simpel und langsam.
   Zurckgegeben wird ein komplexes Objekt, nmlich die Menge aller
   gefundenen Primzahlen, die die erste eines Prchens sind als Integer[].
*/
import java.util.ArrayList;

class JSucheZwillinge implements Job{
  private long von, bis;
  private ArrayList zw1=new ArrayList();

  /* Erzeugt einen Job, der alle Primzahlzwillinge im Bereich [von; bis[
     findet.
  */
  public JSucheZwillinge(long von, long bis){
    this.von=von;
    this.bis=bis;
  }

  public Object losgehts(){
    if(von%2==0) von++;
    //for geht nicht bei long, also while-Schleife
    while(von<bis){
      if(isPrim(von) && isPrim(von+2)) zw1.add(new Long(von));
      von+=2;
    }
    return zw1.toArray();
    //der zurck gegebene Typ ist Object[]
  }

  private boolean isPrim(long z){
    long teiler=1;
    long ende=(long)Math.sqrt(z);
    while(++teiler<ende && z%teiler!=0);//Semikolon fr leere Schleife!
    return z%teiler!=0;
  }
}
