import javax.sound.midi.Track;
import javax.sound.midi.Sequencer;
import javax.sound.midi.Sequence;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.ShortMessage;
import javax.sound.midi.MidiEvent;

public class KlangDemonstrator extends BlindDemonstrator{
  private static int greifInstrument=22;
  private static int tauschInstrument=22;
  private static int normalInstrument=1;
  public Tonfolge tonfolge;
  protected int langsam=1;

  //Es folgt ein static initializer (selten gebraucht);
  //wird einmal ausgefhrt, wenn die Klasse eingeladen wird
  static{standard=new int[]{67,64,64,65,62,62,60,62,64,65,67,67,67};}
  
  public KlangDemonstrator(){
    nimmZahlen(null);
    tonfolge=new Tonfolge();
  }

  public void markierePlatz(int i, int wie){
    //die Positionen sind nicht sinnvoll als Tonhhe darstellbar
    //Man knnte zwar Streichinstrumente fr Dauerton verwenden
    //aber in welcher Tonhhe?
  }
  
  public int gibZahl(int i){
    zugriffe++;
    tonfolge.instrument(greifInstrument);
    tonfolge.hintenNote(zahlen[i],1);
    return zahlen[i];
  }

  public void vertauscheZahlen(int i1, int i2){
    vertauschungen++;
    tonfolge.instrument(tauschInstrument);
    tonfolge.hintenNote(zahlen[i1], 1);
    tonfolge.neueNote(zahlen[i2], tonfolge.lastTick()-1, 1);
    vertausche(i1,i2);
  }

  public boolean korrekt(){
    boolean k=true;
    //vor der Gesamtwiedergabe erst mal eine Pause.
    tonfolge.instrument(normalInstrument);
    tonfolge.hintenPause(2);
    if(zahlen!=null && zahlen.length>0){
      tonfolge.hintenNote(zahlen[0], 1);
      for(int i=1; i<zahlen.length; i++){
        tonfolge.hintenNote(zahlen[i], 1);
        if(zahlen[i]<zahlen[i-1]) k=false;
      }
    }
    return k;
  }
  
  public void verlangsame(int faktor){
    langsam=faktor;
  }

  /** Startet das Abspielen der Tonfolge.
   */
  public void spiele(){
    tonfolge.start(50*langsam);
  }

  /** Gibt zurck, ob noch Tne abzuspielen bleiben.
   *@return true, wenn noch Tne vorhanden sind, sonst false.
   */
  public boolean nochTne(){
    return tonfolge.nochTne();
  }
}
