/*Diese Klasse unterscheidet sich fast nicht von SortKonsole.
 *Ein Unterschied ist, dass die Standardzahlen des Klangdemonstrators
 *verwendet werden und diese anfangs nicht gemischt werden, damit man den
 *Anfang von 'Hnschen klein' erkennt. Diese Noten werden dann aufsteigend
 *sortiert und am Ende abgespielt.
 *Da erst nach dem Sortieren abgespielt werden kann, braucht der Klangdemonstrator
 *einen Startbefehl frs Spielen, der in Demonstrator nicht vorgesehen ist.
 *Deshalb ist 'dem' hier ein KlangDemonstrator und nicht nur ein Demonstrator.
 *Auerdem muss am Schluss gewartet werden, bis alle Tne gespielt sind, daher
 *die while-Schleife. (System.exit ist ntig, weil bei der Tonerzeugung
 *Threads erzeugt wurden, die auch gekillt werden mssen.)
 */
public class SortKonsoleKlang{
  public static void main(String[] args){
    Algorithmus alg=new BubbleSort();
    KlangDemonstrator dem=new KlangDemonstrator();
    alg.setDemonstrator(dem);
    dem.korrekt();//einmal unsortiert ausgeben
    alg.sortiere();
    if(dem.korrekt()) System.out.println("Die Menge ist sortiert.");
    else System.out.println("Die Menge ist nicht sortiert.");
    dem.spiele();
    System.out.println("Anzahl der Zugriffe:       "+dem.anzZugriffe());
    System.out.println("Anzahl der Vertauschungen: "+dem.anzVertauschungen());
    while(dem.nochTne());//leere Schleife wartet auf Ende des 'Liedes'
    System.exit(0);
  }
}

