package servlet;
/*Dieses Servlet zeigt, wie man Header-Daten anzeigt.
 *Diese Datei ist im wesentlichen eine Kopie aus den Tomcat-Beispielen.
 */
import java.io.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class RequestHeaderExample extends HttpServlet {
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException{
		response.setContentType("text/html");

		PrintWriter out = response.getWriter();
		out.println("<html>");
		out.println("<body bgcolor=\"white\">");
		out.println("<head>");
		out.println("<title>Header-Tester</title>");
		out.println("</head>");
		out.println("<body>");

		out.println("<h3>Header-Tester</h3>");
		out.println("<table border=0>");
		Enumeration e = request.getHeaderNames();
		while (e.hasMoreElements()) {
			String headerName = (String)e.nextElement();
			String headerValue = request.getHeader(headerName);
			out.println("<tr><td bgcolor=\"#CCCCCC\">" + headerName);
			out.println("</td><td>" + headerValue + "</td></tr>");
		}
		out.println("</table>");
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
  	  throws IOException, ServletException{
		doGet(request, response);
	}
}
