import java.util.EmptyStackException;//gibt es schon
import java.lang.RuntimeException;

class FullStackException extends RuntimeException{
  //Diese Klasse tut genau dasselbe wie RuntimeException.
  //Wir wollen aber diesen Namen, weil er aussagekrftiger ist.
  public FullStackException(String sagwas){
    super(sagwas);
  }
}

public class IntStackWithExceptions{
  int[] stack;
  int sp=-1;//StackPointer
  
  public IntStackWithExceptions(int gre){stack=new int[gre];}

  public void push(int was) throws FullStackException{
    if(sp+1>=stack.length) throw new FullStackException(
      "Aber hallo, der Stack ist schon voll mit "+(sp+1)+" Elementen!");
    stack[++sp]=was;
  }
  
  public int pull() throws EmptyStackException{
    if(sp<0) throw new EmptyStackException();
    return stack[sp--];
  }
  
  public boolean stackEmpty(){return sp<0;}
}
