public class Krug implements Cloneable{
  protected double volumen;
  protected double fllung;

  public Krug(double v, double f){
    volumen=v;
    setFllung(f);
  }

  public double getVolumen(){return volumen;}

  public double getFllung(){return fllung;}

  public double nimm(double angebot){
    double menge=getVolumen()-getFllung();
    if(angebot<menge) menge=angebot;
    fllung+=menge;
    return menge;
  }

  public void schtteIn(Krug krug){
    double menge=krug.nimm(getFllung());
    fllung-=menge;
  }

  void setFllung(double neu){
    if(neu<0) neu=0;
    else if(neu>volumen) neu=volumen;
    fllung=neu;
  }

  public String toString(){
    return getFllung()+".."+getVolumen();
  }

  public Object clone(){
    Object ret;
    try{ret=super.clone();}
    catch(CloneNotSupportedException ex){ret=null;}//passiert nicht
    return ret;
  }

  public boolean equals(Object obj){
    if(!(obj instanceof Krug)) return false;
    return ((Krug)obj).getVolumen()==getVolumen();
  }

  public int hashCode(){return (int)getVolumen();}

  //Die folgende Methode wird nach der Testphase entfernt
  public static void main(String[] args){
    Krug s8=new Krug(8,8);
    Krug s5=new Krug(5,0);
    Krug s3=new Krug(3,0);
    //Auftrag: Erzeuge zwei Krge mit Inhalt 4
    System.out.println(s8+" "+s5+" "+s3);
    s8.schtteIn(s5); System.out.println(s8+" "+s5+" "+s3);
    s5.schtteIn(s3); System.out.println(s8+" "+s5+" "+s3);
    s3.schtteIn(s8); System.out.println(s8+" "+s5+" "+s3);
    s5.schtteIn(s3); System.out.println(s8+" "+s5+" "+s3);
    s8.schtteIn(s5); System.out.println(s8+" "+s5+" "+s3);
    s5.schtteIn(s3); System.out.println(s8+" "+s5+" "+s3);
    s3.schtteIn(s8); System.out.println(s8+" "+s5+" "+s3);
  }
}