import java.util.ArrayList;//dynamische Arrays mit beliebigem Inhalt

public class KrugSpiel implements ProcessListener{
  ArrayList krge=new ArrayList();//Krge im Anfangszustand
  ArrayList start=new ArrayList();//Fllungen im Anfangszustand
  ArrayList soll =new ArrayList();//Sollfllung
  int schritte;
  private ArrayList listeners=new ArrayList();

  public KrugSpiel(Krug[] kr, double[] so){
    for(int i=0; i<kr.length; i++) addKrug(kr[i], so[i]);
  }

  public void addKrug(Krug k, double s){
    if(s<0) s=0;
    if(s>k.getVolumen()) s=k.getVolumen();
    krge.add(k);
    start.add(new Double(k.getFllung()));
    soll .add(new Double(s));
  }

  public void resetAllTransfers(){
    schritte=0;
    for(int i=0; i<krge.size(); i++)
      getKrug(i).setFllung(getStart(i));
    fireSpielEvent();
  }

  public void processTransfer(int a, int b){
    getKrug(a).schtteIn(getKrug(b));
    schritte++;
    fireSpielEvent();
  }

  public int getAnzahl(){return krge.size();}

  public Krug getKrug(int i){return (Krug)krge.get(i);}

  public double getSoll(int i){
    return ((Double)soll.get(i)).doubleValue();
  }

  public double getStart(int i){
    return ((Double)start.get(i)).doubleValue();
  }

  public int getSchritte(){return schritte;}

  public boolean isFertig(){
    boolean fertig=true;
    for(int i=0; i<krge.size(); i++)
      fertig&=getKrug(i).getFllung()==getSoll(i);
    return fertig;
  }

  public void addSpielListener(SpielListener s){listeners.add(s);}

  public void removeSpielListener(SpielListener s){listeners.remove(s);}

  protected void fireSpielEvent(){
    SpielEvent e=new SpielEvent(this, getSchritte(), isFertig());
    for(int i=0; i<listeners.size(); i++)
      ((SpielListener)listeners.get(i)).neuerSpielstand(e);
  }
}
