import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Main{
  public static void guiAufbau(Container c){
    KrugSpiel ks=new KrugSpiel(
      new Krug[]{new See(), new Krug(8,0), new Krug(5,0), new Krug(3, 0)},
      new double[]{Double.POSITIVE_INFINITY, 4, 4, 0}
    );
    //erzeuge den Reset-Button
    ResetButton reset=new ResetButton("Startsituation", ks);
    c.add(reset, BorderLayout.NORTH);
    //erzeuge die Anzeige der bentigten Schritte
    AnzeigeLabel al=new AnzeigeLabel();
    ks.addSpielListener(al);
    c.add(al, BorderLayout.SOUTH);
    //Erzeuge die Matrix
    int anz=ks.getAnzahl();
    JPanel p=new JPanel(new GridLayout(anz, anz+1));
    c.add(p, BorderLayout.CENTER);
    for(int zeile=0; zeile<anz; zeile++){
      for(int spalte=0; spalte<anz; spalte++)
        if(zeile==spalte){
          TransferLabel tl=new TransferLabel();
          ks.getKrug(zeile).addTransferListener(tl);
          p.add(tl);
        } else{
          ProcessButton pb=new ProcessButton(ks,zeile,spalte);
          p.add(pb);
        }
      JLabel soL=new JLabel(ks.getSoll(zeile)+"");//+"" kleiner Trick!
      soL.setHorizontalAlignment(JLabel.CENTER);
      p.add(soL);
    }
    ks.resetAllTransfers();
  }

  public static void main(String[] args){
    JFrame f=new JFrame("Krugspiel");
    f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    Container c=f.getContentPane();//hat BorderLayout
    guiAufbau(c);
    f.pack();
    f.show();
  }
}
