public class Fibonacci{
	//rekursive Definition
  public static int fibRek(int n){
    if(n<=2) return 1;
    return fibRek(n-1)+fibRek(n-2);
  }
  
	//iterative Definition
  public static int fibIter(int n){
    int f1=1, f2=1, f;
    for(int i=2; i<n; i++){
      f=f1+f2;
      f1=f2;
      f2=f;
    }
    return f2;
  }

  static public void main(String[] args){
    System.out.println(fibRek(1));
    System.out.println(fibRek(2));
    System.out.println(fibRek(3));
    System.out.println(fibRek(8));
    System.out.println(fibIter(1));
    System.out.println(fibIter(2));
    System.out.println(fibIter(3));
    System.out.println(fibIter(8));
  }
}
