/* Die for-Schleife ist die wichtigste in Java. In Klammern knnen
   durch Semikolon getrennt, bis zu drei Argumente
   angegeben werden. Das erste ist einen Initialisierungsanweisung,
   die genau einmal durchgefhrt wird. Das zweite ist die Wiederholungs-
   bedingung und wird vor jedem anstehenden Durchlauf getestet (die
   Schleife wird also evtl. gar nicht durchlaufen) und das dritte ist
   eine Anweisung, die am Ende jedes Durchlaufs ausgefhrt wird. Meist
   handelt es sich um sowas wie i++ oder i--.
*/
public class For{
  public static void main(String[] args){
    for(int i=0; i<5; i++) System.out.print("Hallo ");
    for(int i=0; i<5;){
      System.out.print("so geht's auch. ");
      i++;
    }
    System.out.println("");
    for(int i=0; i<5; i++) System.out.println(i+". Hallo ");
    for(int i=4; i<5; i++) System.out.println(i);
    for(int i=5; i<5; i++) System.out.println("Siehst du mich?");
    LineInput.readString();//nur als Ausgabebremse
    //Nun einmal mit Tonausgabe
    Tonfolge tf=new Tonfolge();
    tf.instrument(7);
    for(int i=60; i<80; i++) tf.hintenNote(i, 1);
    tf.start(120);
    System.out.println("Taste drcken zum Beenden!");
    LineInput.readString();//Bremse
    //der folgende Befehl ist ntig, um den tonerzeugenden Thread gewaltsam
    //zu beenden. Er wartet nmlich immer weiter auf eintrudelnde Noten und
    //kann nicht wissen, dass wir nicht beabsichtigen, weitere zu senden.
    System.exit(0);
  }
}
