public class Kollektion{
  private static Knoten start;

  private static void init(){
    start=null;
  }

  public static boolean istLeer(){
    return start==null;
  }

  public static void einfuegen(int zahl){
    Knoten element=new Knoten();
    element.next=start;
    element.info=zahl;
    start=element;
  }

  public static int wieOftDrin(int zahl){
    int n=0;
    Knoten p=start;
    while(p!=null){
      if(p.info==zahl) n++;
      p=p.next;
    }
    return n;
  }

  public static void entfernen(int zahl){
    Knoten zero=new Knoten();
    zero.next=start;
    Knoten vor =zero;
    Knoten lauf=start;
    while(lauf!=null){
      if(lauf.info==zahl){
        vor.next=lauf.next;
        lauf=null;//so etwas wie dispose ist nicht ntig
        start=zero.next;
      } else{
        vor =lauf;
        lauf=lauf.next;
      }
    }
  }

  //Die Kollektion muss vor dem Gebrauch initialisiert werden.
  static{
    init();
  }
}

class Knoten{
  public int info;
  public Knoten next;
}
