/* Dieser einfache Job kennt eine Zahl und soll von dieser feststellen,
   ob sie prim ist.
   Zurckgeliefert msste nur ein boolean werden, der aber wegen des
   allgemein angelegten Rckgabetyps Object in ein Boolean verpackt wird.
*/
import java.math.BigInteger;

public class JWahrscheinlichPrim implements Job{
  private BigInteger meinezahl;
  private int quali;

  public JWahrscheinlichPrim(BigInteger zahl, int q){
    meinezahl=zahl;
    quali=q;
  }

  public Object losgehts(){
    return new Boolean(meinezahl.isProbablePrime(quali));
  }
}
