import javax.swing.JPanel;
import java.util.Random;
import java.awt.*;
import java.awt.geom.Line2D;

public class StabDemonstrator extends JPanel implements Demonstrator{
  protected static int[] standard={3,1,2,2,5,4};
  protected int zugriffe=0;
  protected int vertauschungen=0;
  protected int langsam=1;
  protected int[] zahlen={2,1,3};
  protected Color[] stab=new Color[zahlen.length];
  protected Color[] schatten=new Color[zahlen.length];
  protected static Random zufall=new Random();
  protected static Color[] farben={null, Color.BLACK,Color.WHITE,Color.BLUE,Color.RED,Color.GREEN};
  
  public StabDemonstrator(){
    setOpaque(false);
  }
  
  public int anzVertauschungen(){
    return vertauschungen;
  }
  
  public int anzZugriffe(){
    return zugriffe;
  }
  
  public int anzahl(){
    return zahlen.length;
  }
  
  public void nimmZahlen(int[] z){
    vertauschungen=0;
    zugriffe=0;
    zahlen=z==null?(int[])standard.clone():z;
    stab=new Color[zahlen.length];
    schatten=new Color[zahlen.length];
  }
  
  public void mischen(){
    int t,r,n=zahlen.length;
    Color c;
    for(int i=0; i<n; i++){
      r=zufall.nextInt(n);
      vertausche(r,i);
    }
    vertauschungen=0;
    zugriffe=0;
    repaint();
  }
  
  public void markierePlatz(int i, int wie){
    schatten[i]=(wie>=0 && wie<farben.length)?farben[wie]:farben[0];
    repaint();
  }
  
  public int gibZahl(int i){
    zugriffe++;
    Color t=stab[i];
    stab[i]=Color.ORANGE;
    repaint();
    try {Thread.sleep(20*langsam);} catch (InterruptedException e){}
    stab[i]=t;
    return zahlen[i];
  }

  private void vertausche(int i1, int i2){
    int t; Color c;
    t=zahlen[i1];
    zahlen[i1]=zahlen[i2];
    zahlen[i2]=t;
    c=stab[i1];
    stab[i1]=stab[i2];
    stab[i2]=c;
  }
  
  public void vertauscheZahlen(int i1, int i2){
    vertauschungen++;
    Color c1=stab[i1], c2=stab[i2];
    stab[i1]=stab[i2]=Color.MAGENTA;
    repaint();
      try {Thread.sleep(50*langsam);} catch (InterruptedException e){}
    stab[i1]=c1; stab[i2]=c2;
    vertausche(i1,i2);
    repaint();
  }

  private Line2D.Double line=new Line2D.Double();
  private static final int dick=5;
  private Stroke back=new BasicStroke(dick);
  private Stroke pen =new BasicStroke(dick-2);
  public void paint(Graphics g){
    java.awt.Graphics2D g2=(Graphics2D)g;
    g2.setStroke(pen);
    Color hinter=getBackground();
    int w=getWidth();
    int h=getHeight();
    for(int i=zahlen.length; --i>=0;){
      line.x1=line.x2=dick/2+dick*i;
      line.y2=h;
      g2.setColor(schatten[i]==null?hinter:schatten[i]);
      g2.setStroke(back);
      g2.draw(line);
      line.y2=zahlen[i];
      g2.setColor(stab[i]==null?Color.BLACK:stab[i]);
      g2.setStroke(pen);
      g2.draw(line);
    }
  }
  
  public boolean korrekt(){
    repaint();
    for(int i=zahlen.length; --i>0;)
      if(zahlen[i-1]>zahlen[i]) return false;
    return true;
  }
  
  public void verlangsame(int faktor) {
    langsam=faktor;
  }
}
