/* Diese Klasse wird von dem Beispiel kursdatenbank.jsp verwendet. Die Klasse
 * erfllt die Anforderungen einer Java-Bean und stellt auerdem eine Verbindung
 * zu einer Datenbank her.
 */
package beans;

import javax.servlet.http.*;
import java.sql.*;

public class KursBean {
  private String name1;//Vorname
  private String name2;//Nachname
	private String sex;//m=mnnlich; f=weiblich
  private String email;
  private String klasse;
  private String leiter;//Klassleiter
	private String aktion;//falls mehrere Submitbuttons mit Name aktion vorhanden sind,
	                      //kann ber ihren Wert ermittelt werden, welcher gedrckt wurde.

  public KursBean(){reset();}

  public void reset(){
		name1="";
    name2="";
    sex="";
    email="";
    klasse="";
    leiter="";
		aktion="";
  }

  public String getName1() {return name1;}
  public String getName2() {return name2;}
  public String getEmail() {return email;}
  public String getSex()   {return sex;}
  public String getKlasse(){return klasse;}
  public String getLeiter(){return leiter;}
  public String getAktion(){return aktion;}

  public void setName1 (String s){name1=s;}
  public void setName2 (String s){name2=s;}
  public void setSex   (String s){sex=s;}
  public void setEmail (String s){email=s;}
  public void setKlasse(String s){klasse=s;}
  public void setLeiter(String s){leiter=s;}
  public void setAktion(String s){aktion=s;}

  public void processRequest(HttpServletRequest request){
		Connection c=null;
		try{
      /*Die folgenden beiden Zeilen fhren nur dann zum Erfolg, wenn Sie einen
        mysql-Server laufen haben (Standard-Port 3306) und die Datenbank "kurs"
        mit der Tabelle "schueler" eingerichtet haben.
        schueler muss die Rubriken name1, name2, sex, email, klasse, leiter
        haben (in dieser Reihenfolge).
        Der jdbc:mysql-Treiber befindet sich im Ordner classes/org. Sie brauchen
        sich um diesen nicht zu kmmern.
       */
			Class.forName ("org.gjt.mm.mysql.Driver");
			c=DriverManager.getConnection ("jdbc:mysql://:3306/kurs?user=gow&password=gowpass");
      /*Wahlweise knnen Sie auch den jdbc-odbc-Treiber verwenden.*/
			//Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");
			//c=DriverManager.getConnection("jdbc:odbc:kurs","gow","gowpass");

      /*Wenn Sie keine Verbindung zu Ihrem mysql-Server bekommen, dann liegt das
       *evtl. daran, dass das Attribut skip-networking gesetzt ist (in Linux finden
       *Sie das in /etc/mysql/my.cnf
       *Kommentieren Sie das aus und starten Sie den mysql-Server neu. Wenn alles
       *gut gegangen ist, dann zeigt der Befehl "netstat -tlnp" an, dass mysqld
       *auf Port 3306 lauscht.
      */

			if(c!=null) {
				//System.out.println ("Verbindung hergestellt...");
				Statement s=c.createStatement();
				String sql;
				ResultSet rs;

				sql="SELECT COUNT(*) FROM schueler WHERE name2=\'"+getName2()+"\'";
				rs=s.executeQuery(sql);
				int fehlt=getName1().length()*getName2().length()*getEmail().length()
				    *getKlasse().length()*getLeiter().length();
				rs.next();//fahre auf den ersten Eintrag - der existiert sicher
				int anz=rs.getInt(1);//die Spaltennummern beginnen bei 1
				if(fehlt==0 || anz>0) setName2("");//existierender Nachname wie fehlender
				else{
					sql="INSERT INTO schueler VALUES(\'"+getName1()+"\',\'"+getName2()+"\',\'"
					    +getSex()+"\',\'"+getEmail()+"\',\'"+getKlasse()+"\',\'"+getLeiter()+"\')";
					s.executeUpdate(sql);
				}
				//System.out.println("Verbindung wird geschlossen...");
				c.close ();
			}
		} catch (Exception e){ System.out.println ("Oops! "+e);}
  }
}
