/* Diese Klasse wird von dem Beispiel kursdatenfile.jsp verwendet. Die Klasse
 * erfllt die Anforderungen einer Java-Bean und stellt auerdem den Zugriff
 * auf die Datei kursdaten.txt im User-Verzeichnis her. Wenn die Datei nicht
 * existiert, wird sie angelegt.
 */
package beans;

import javax.servlet.http.*;
import java.io.*;

public class KursBean2 {
  private File datei=new File("/home/harri/kursdaten.txt");
  /*private File datei=new File(System.getProperty("user.dir")+File.separatorChar
                     +"kursdaten.txt");*/
  private String name1;//Vorname
  private String name2;//Nachname
	private String sex;//m=mnnlich; f=weiblich
  private String email;
  private String klasse;
  private String leiter;//Klassleiter
	private String aktion;//falls mehrere Submitbuttons mit Name aktion vorhanden sind,
	                      //kann ber ihren Wert ermittelt werden, welcher gedrckt wurde.

  public KursBean2(){reset();}

  public void reset(){
		name1="";
    name2="";
    sex="";
    email="";
    klasse="";
    leiter="";
		aktion="";
  }

  public String getName1() {return name1;}
  public String getName2() {return name2;}
  public String getEmail() {return email;}
  public String getSex()   {return sex;}
  public String getKlasse(){return klasse;}
  public String getLeiter(){return leiter;}
  public String getAktion(){return aktion;}

  public void setName1 (String s){name1=s;}
  public void setName2 (String s){name2=s;}
  public void setSex   (String s){sex=s;}
  public void setEmail (String s){email=s;}
  public void setKlasse(String s){klasse=s;}
  public void setLeiter(String s){leiter=s;}
  public void setAktion(String s){aktion=s;}

  /*Diese Methode hngt den eingehenden Datensatz an eine Datei an.
   */
  public void processRequest(HttpServletRequest request){
    String neu=getName2()+","+getName1()+";"+getSex()+";"+getEmail()+";"
              +getKlasse()+";"+getLeiter();
    try{
      //Erzeuge temporre Datei, egal wo...
      File tmpf=File.createTempFile("kursdaten",".tmp");
      tmpf.deleteOnExit();
      BufferedReader br=datei.canRead()?new BufferedReader(new FileReader(datei)):null;
      BufferedWriter bw=new BufferedWriter(new FileWriter(tmpf.getPath()));
      bw.write(neu+"\r\n");
      if(br!=null){
        String alt=null;
        while((alt=br.readLine())!=null) bw.write(alt+"\r\n");
        br.close();
        datei.delete();
      }
      bw.close();
      tmpf.renameTo(datei);
      System.out.println("Bearbeitete Datei: "+datei);
    } catch(IOException ex){System.err.println(ex);}
  }
}
