package servlet;
/*Dies ist ein Servlet, also ein auf dem Server laufendes Java-Programm.
 *Es erzeugt eine html-Datei mit einem Formular, dessen Daten an diese
 *selbe Datei gesendet werden. Danach wird die gleiche Seite erneut erzeugt.
 *Sobald also an dieses Servlet Daten gepostet oder gegettet werden, ruft
 *es fortwhrend sich selber auf.
 *Diese Datei ist im wesentlichen eine Kopie aus den Tomcat-Beispielen.
 */
import java.io.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class RequestParamExample extends HttpServlet {

	public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException{
		response.setContentType("text/html");

		PrintWriter out = response.getWriter();
		out.println("<html>");
		out.println("<body>");
		out.println("<head>");
		out.println("<title>Parameter-Tester</title>");
		out.println("</head>");
		out.println("<body bgcolor=\"white\">");

		out.println("<h3>Parameter-Tester</h3>");
		String name = request.getParameter("anwenderName");
		String mail = request.getParameter("anwenderMail");
		out.println("<br>");
		if (name != null || mail != null) {
				out.println("Name: ");
				out.println(name + "<br>");
				out.println("Mail: ");
				out.println(mail);
		} else {
				out.println("--- keine Angaben vorhanden ---");
		}
		out.println("<P>");
		out.print("<form action=\"");
//		out.print("RequestHeaderExample\" ");
		out.print("RequestParamExample\" ");
		out.println("method=POST>");
		out.println("Name");
		out.println("<input type=text size=20 name=anwenderName>");
		out.println("<br>");
		out.println("Mail");
		out.println("<input type=text size=20 name=anwenderMail>");
		out.println("<br>");
		out.println("<input type=submit>");
		out.println("</form>");

		out.println("</body>");
		out.println("</html>");
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException{
		doGet(request, response);
	}
}
